﻿@model List<eCommerce.BackOffice.ViewModels.ProductViewModel>
@{
    ViewBag.Title = "Edición Rapida";
    Layout = "~/Views/Shared/_ListLayout.cshtml";
}

<div class="page-header">
    <h1 class="page-title">Edición Rapida</h1>
    <div class="page-header-actions">
        <div class="btn-group btn-group-sm" id="withBtnGroup" aria-label="Page Header Actions" role="group">
            
            <button type="button" class="btn btn-outline btn-primary" onclick="OpenMassiveUpdateModal()">
                <i class="icon wb-edit" aria-hidden="true"></i>
                <span class="hidden-xs">MODIFICACIÓN MASIVA</span>
            </button>

            @if (Request["onlyStock"] != null && Request["onlyStock"] == "1")
            {
                <button type="button" class="btn btn-outline btn-primary" onclick="switchOnlyStock(1)">
                    <i class="icon fa-archive" aria-hidden="true"></i>
                    <span class="hidden-xs">MOSTRAR TODOS</span>
                </button>

            }
            else
            {
                <button type="button" class="btn btn-outline btn-primary" onclick="switchOnlyStock(0)">
                    <i class="icon fa-archive" aria-hidden="true"></i>
                    <span class="hidden-xs">SOLO CON STOCK</span>
                </button>
            }

            </div>
    </div>
</div>


<div class="page-content">

    <div class="panel">
        @Html.Partial("_FastEditList", Model)
    </div>

</div>

<!-- Modal -->
<div id="CategoryUpdate" class="modal fade" role="dialog">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal">&times;</button>
                <h4 class="modal-title">Actualizar Categoria</h4>
            </div>
            <div class="modal-body">
            </div>
        </div>
    </div>
</div>
<!-- End Modal -->

<div id="MassiveUpdate" class="modal fade" role="dialog">
    <div class="modal-dialog">

        <!-- Modal content-->
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal">&times;</button>
                <h4 class="modal-title">Modificación masiva de precios</h4>
            </div>
            <div class="modal-body">
                <div class="form-group">
                    <div class="radio-custom radio-primary radio-inline">
                        <input type="radio" id="radioMultiply" name="inputOperator" value="multiply" tabindex="-1" checked>
                        <label for="radioMultiply">Multiplicar</label>
                    </div>
                    <div class="radio-custom radio-primary radio-inline">
                        <input type="radio" id="radioDivide" name="inputOperator" value="divide" tabindex="-1">
                        <label for="radioDivide">Volver al precio anterior</label>
                    </div>
                </div>
                <div class="form-group">
                    <div class="form-group">
                        <label class="control-label" for="MassiveUpdateValue">Valor multiplicador:</label>
                        <input type="number" class="form-control" id="MassiveUpdateValue" name="MassiveUpdateValue" placeholder="Ej. 0,8 - representaría un 20%" autocomplete="off">
                    </div>
                    <div class="form-group">
                        <select id="categoryIds" class="form-control" data-plugin="select2">
                            <option value="-1">Todas las categorás</option>
                        </select>
                    </div>
                    <div class="form-group">
                        <div class="checkbox-custom checkbox-primary">
                            <input type="checkbox" id="chkRetailPrice" name="chkRetailPrice" checked />
                            <label for="chkRetailPrice">Minorista</label>
                        </div>
                        <div class="checkbox-custom checkbox-primary">
                            <input type="checkbox" id="chkWholesalePrice" name="chkWholesalePrice" />
                            <label for="chkWholesalePrice">Mayorista</label>
                        </div>
                    </div>
                </div>
                

            </div>
            <div class="modal-footer">
                <button onclick="MassivePriceUpdateConfirmation()" type="button" class="btn btn-primary">Aceptar</button>
                <button onclick="ResetMassiveUpdateInputs()" type="button" class="btn btn-default" data-dismiss="modal">Cancelar</button>
            </div>
        </div>
    </div>
</div>

<style type="text/css">
    .select2-close-mask {
        z-index: 2099;
    }

    .select2-dropdown {
        z-index: 3051;
    }
</style>

@section Scripts {
    
    <script src="/Content/assets/vendor/editable-table/mindmup-editabletable.js"></script>
    <script src="/Content/assets/vendor/editable-table/numeric-input-example.js"></script>
    <script src="/Content/assets/js/components/editable-table.js"></script>
    
    <script type="text/javascript">

        $(document).ready(function () {
        })

        function switchOnlyStock(current)
        {
            if (current == 0) {
                window.location.search = "?onlyStock=1";
            } else {
                window.location.search = "?onlyStock=0";
            }
        }

        $('#editableTable').editableTableWidget({ editor: $('<input>'), preventColumns: [1, 3, 6, 7] });

        $('table td').on('validate', function (evt, newValue) {
            if ($(this).attr("id").startsWith("StockVirtual") || $(this).attr("id").startsWith("Categoria") || $(this).attr("id").startsWith("Published"))
            {
                return false;
            }
        });


        $('table td').on('change', function (evt, newValue) {

            //var productId = this.id.split('-')[1];
            //var attribute = this.id.split('-')[0];

            //if (newValue != null && attribute == "StockReal")
            //{
            //    /*$.ajax({
            //        url: "/Products/StockUpdate/",
            //        type: "POST",
            //        data: { ProductId: productId, NewStock: newValue},
            //        success: function (data, textStatus, jqXHR)
            //        {
            //            if(data=="error")
            //            {
            //                toastr.error('Error al modificar datos.');
            //            }
            //            else if (data.includes("stockVirtualError"))
            //            {
            //                toastr.error('Error, el valor ingresado dejaría el stock virtual en negativo.');
            //                $("#StockReal-" + productId).text(data.split("/")[1]);
            //            }
            //            else
            //            {
            //                $("#StockVirtual-" + productId).text(data);
            //                $("#StockReal-" + productId).text(newValue);
            //                toastr.success('Datos modificados');

            //            }
            //        }
            //    });*/
            //}
            //else
            //{
            //    if (newValue != null)
            //    {
            //        $.ajax({
            //            url: "/Products/FastEdit/",
            //            type: "POST",
            //            data: { ProductId: productId, Atributo: attribute, NewValue: newValue},
            //            success: function (data, textStatus, jqXHR)
            //            {
            //                if(data=="error")
            //                {
            //                    toastr.error('Error al modificar datos.');
            //                } else if (data.includes("CodigoRepetido")) {
            //                    toastr.error('Error, ya hay un producto con el codigo ingresado.');
            //                    $("#Code-" + productId).text(data.split("/")[1]);
            //                }
            //                else
            //                {
            //                    $("#" + attribute + "-" + productId).text(data);
            //                    toastr.success('Datos modificados');
            //                }
            //            }
            //        });
            //    }
            //}

            var productId = this.id.split('-')[1];
            var attribute = this.id.split('-')[0];

            if (newValue != null) {
                $.ajax({
                    url: "/Products/FastEdit/",
                    type: "POST",
                    data: { ProductId: productId, Atributo: attribute, NewValue: newValue },
                    success: function (data, textStatus, jqXHR) {
                        if (data == "error") {
                            toastr.error('Error al modificar datos.');
                        } else if (data.includes("CodigoRepetido")) {
                            toastr.error('Error, ya hay un producto con el codigo ingresado.');
                            $("#Code-" + productId).text(data.split("/")[1]);
                        }
                        else {
                            $("#" + attribute + "-" + productId).text(data);
                            toastr.success('Datos modificados');
                        }
                    }
                });
            }
        });

        function PublishedStatusUpdate(productId)
        {
            debugger;
            $.ajax({
                url: "/Products/PublishStatusUpdate/",
                type: "POST",
                data: { ProductId: productId},
                success: function (data, textStatus, jqXHR) {
                    if (data == "published") {
                        $("#Published-" + productId).html('<span class="label label-outline label-success"  ondblclick="PublishedStatusUpdate(' + productId + ')">Si</span>');
                        toastr.success('Datos modificados');
                    } else if (data == "unpublished") {
                        $("#Published-" + productId).html('<span class="label label-outline label-danger"  ondblclick="PublishedStatusUpdate(' + productId + ')">No</span>');
                        toastr.success('Datos modificados');
                    } else if (data == "error") {
                        toastr.error('Error al modificar datos.');
                    }
                }
            });
        }

        function OnSaleStatusUpdate(productId) {
            $.ajax({
                url: "/Products/OnSaleStatusUpdate/",
                type: "POST",
                data: { ProductId: productId },
                success: function (data, textStatus, jqXHR)
                {
                    if (data == "true") {
                        $("#OnSale-" + productId).html('<span class="label label-outline label-success"  ondblclick="OnSaleStatusUpdate(' + productId + ')">Si</span>');
                        toastr.success('Datos modificados');
                    } else if (data == "false") {
                        $("#OnSale-" + productId).html('<span class="label label-outline label-danger"  ondblclick="OnSaleStatusUpdate(' + productId + ')">No</span>');
                        toastr.success('Datos modificados');
                    } else if (data == "error") {
                        toastr.error('Error al modificar datos.');
                    }
                }
            });
        }

        function OpenModal(productId)
        {
            $("#CategoryUpdate").modal();

            $.ajax({
                url: "/Products/CategoryUpdateModal/",
                type: "GET",
                data: { productId: productId},
                success: function (data, textStatus, jqXHR) {
                    $('.modal-body').html(data);
                    $("#CategoryId").select2();
                }
            });
        }
        
        function UpdateCategory(productId)
        {
            var categoryId = $("#CategoryId").val();
            $.ajax({
                url: "/Products/CategoryUpdate/",
                type: "GET",
                data: { productId: productId, categoryId: categoryId },
                success: function (data, textStatus, jqXHR) {
                    if(data != "error")
                    {
                        $("#Categoria-" + productId).text(data)
                        toastr.success('Categoria actualizada');
                    } else {
                        toastr.error('Error al modificar datos.');
                    }
                }
            });
        }

        function OpenMassiveUpdateModal() {
            $.ajax({
                url: "/Products/GetCategories/",
                type: "GET",
                data: {},
                success: function (data, textStatus, jqXHR) {
                    if (data != "error") {
                        $("#MassiveUpdate").modal();
                        control = $("#categoryIds");
                        $.each(data.Categories, function (index, item) {
                            control.append($('<option value=' + item.CategoryId + '>' + item.Name + '</option>'));
                        });
                    }
                }
            });
        }
        function CancelMassiveUpdate() {
            $("[data-dismiss=modal]").click()
        }
        function MassivePriceUpdateConfirmation()
        {
            if (ValidateMassiveUpdateSubmit()) 
            {
                var value = $("#MassiveUpdateValue").val().trim();
                var operationType = $("[name='inputOperator']:checked").val();

                var updateRetailPrice = $("[name='chkRetailPrice']:checked").val() == "on";
                var updateWholesalePrice = $("[name='chkWholesalePrice']:checked").val() == "on";

                var title = "¿Está seguro que quiere modificar todos los precios?";

                swal({
                    title: title,
                    text: "",
                    type: "warning",
                    showCancelButton: true,
                    confirmButtonColor: '#DD6B55',
                    confirmButtonText: 'Si, actualizar',
                    cancelButtonText: "Cancelar",
                    closeOnConfirm: false,
                    closeOnCancel: false
                },
                function (isConfirm)
                {
                    if (isConfirm) {
                        MassiveUpdatePrice(value, operationType, updateRetailPrice, updateWholesalePrice);

                    } else {
                        swal("Cancelado", "La operación se ha cancelado", "error");
                    }
                });
            }
        }

        function MassiveUpdatePrice(value, operationType, updateRetailPrice, updateWholesalePrice)
        {
            $.ajax({
                url: "/Products/MassivePriceUpdate",
                type: "POST",
                data: { CategoryId: $("#categoryIds").val(), Value: value, OperationType: operationType, UpdateRetailPrice: updateRetailPrice, UpdateWholesalePrice: updateWholesalePrice },
                success: function (data, textStatus, jqXHR)
                {
                    if (data.Message === "Success")
                    {
                        swal("¡Precios Actualizados!", "Los precios han sido actualizados", "success");
                        $("[data-dismiss=modal]").click();
                        location.reload();
                    }
                    else
                    {
                        swal("Error", "Se produjo un error al intentar actualizar los precios", "error");
                    }
                }
            });
        }

        function RefreshPartial() {
            $.ajax({
                url: "/Products/GetProductsPartial/",
                type: "GET",
                success: function (data, textStatus, jqXHR) {
                    $('.page-content > .panel').html(data);
                    $('#editableTable').dataTable();
                    $('#editableTable').editableTableWidget({ editor: $('<input>'), preventColumns: [3, 5] });
                }
            });
        }

        function ResetMassiveUpdateInputs()
        {
            $("#MassiveUpdateValue").val(0);
            $("#OldPriceDifference").val(0);
        }

        function ValidateMassiveUpdateSubmit()
        {
            var valid = true;
            var operationType = $("[name='inputOperator']:checked").val();
            
            if (operationType == "multiply")
            {
                var valueInput = $("#MassiveUpdateValue");
                if (valueInput.val().trim().length == 0 || valueInput.val() == 0) {
                    valueInput.parent().addClass('has-error')
                    valid = false;
                } else {
                    valueInput.parent().removeClass('has-error')
                }
            }

            return valid;
        }


    </script>



}

